/*
 * IoT Services Management System - 2021
 * See LICENSE for more information about licensing
 *
 * Author: Jose Ortega <ortega.josant@gmail.com>
 *         Luis G. Leon Vega <lleon95@gmail.com>
 *
 * Sponsor: Klooid Innovations 2021
 */

#ifndef PROJECT_NAME
#define PROJECT_NAME "isms-kernel"

#include <iostream>
#include <memory>
#include <thread>

#include <IIpcModule.hpp>
#include <IProcessController.hpp>
#include <IScheduler.hpp>
#include <IServiceController.hpp>
#include <serialization.hpp>

/**
 * Autogenerated main for Meson empty project
 */
int main(int argc, char** argv) {
  if (argc != 1) {
    std::cout << argv[0] << "takes no arguments" << std::endl;
    return 1;
  }

  auto s_controller = isms::kn::IServiceController::Build();
  auto scheduler = isms::kn::IScheduler::Build();
  auto p_controller = isms::kn::IProcessController::Build();

  auto ipc_mod = isms::kn::IIpcModule::Build();
  ipc_mod->set_comm_protocol("ipc");
  ipc_mod->set_endpoint("kernel_0.ipc");
  ipc_mod->set_service_controller(s_controller);
  ipc_mod->set_process_controller(p_controller);
  ipc_mod->set_scheduler(scheduler);

  scheduler->set_ipc_module(ipc_mod);

  p_controller->set_service_controller(s_controller);
  p_controller->set_scheduler(scheduler);
  s_controller->set_scheduler(scheduler);
  scheduler->StartScheduling();

  std::cout << "Starting Kernel: " << std::endl;
  ipc_mod->InitIpc();
}

#endif
